/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0S/Kx1+
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2012
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0S/Kx1+ V2.41 [9 Sep. 2008]
**
**  Device :	uPD78F9212
**
**  Compiler :	CC78K0S
**
**  Creation date:	2012/01/31
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "port.h"
#include "int.h"
#include "timer.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
unsigned char	set_count;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw5_key;
unsigned char	sw5_rep;
unsigned char	sw6_key;
unsigned char	sw6_rep;
unsigned char	sw7_key;
unsigned char	sw7_rep;
unsigned char	sw8_key;
unsigned char	sw8_rep;
unsigned char	sw9_key;
unsigned char	sw9_rep;
unsigned char	sw10_key;
unsigned char	sw10_rep;
unsigned char	sw11_key;
unsigned char	sw11_rep;
unsigned char	sw12_key;
unsigned char	sw12_rep;




unsigned char	ch;

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
void	head_out(void)
{
	set_count=16;
	/*TMH1_Start();*/
	TM00_Start();
	while(set_count>0){}
	TM00_Stop();
	/*TMH1_Stop();*/
}
void	data1_out(void)
{
	set_count=4;
	/*TMH1_Start();*/
	while(set_count>0){}
	/*TMH1_Stop();*/
	set_count=8;
	/*TMH1_Start();*/
	TM00_Start();
	while(set_count>0){}
	TM00_Stop();
	/*TMH1_Stop();*/
}
void	data0_out(void)
{
	set_count=4;
	/*TMH1_Start();*/
	while(set_count>0){}
	/*TMH1_Stop();*/
	set_count=4;
	/*TMH1_Start();*/
	TM00_Start();
	while(set_count>0){}
	TM00_Stop();
	/*TMH1_Stop();*/
}
void	data6_out(unsigned char data)
{
unsigned char d,i;

	for(i=0;i<6;i++){
		d=data & 0x01;
		if(d==0x01){data1_out();}
		else{data0_out();}
		data=data>>1;
	}
}
void	wait_10msec(void)
{
	set_count=92;
	TMH1_Start();
	while(set_count>0){}
	TMH1_Stop();
}
unsigned char ch_in(void)		/* Dch only */
{
unsigned char data;

	data=0;
	data=data|0x03;

	return data;
}
void	rem_out(unsigned char data)
{
	TMH1_Start();
	head_out();
	data6_out(data|ch);
	wait_10msec();
	TMH1_Stop();
	
}

void 	main( void )
{
unsigned char off_flg;

	off_flg=0;
	
	ch=ch_in();

	INTP1_Enable();

	/* TODO. add user code */
	while(1){
	/* key scan 1 */
		if (P2.0==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if (P4.1==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/
		if (P4.0==0){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
		}
		/*------------------*/
		if (P4.7==0){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
		}
		/*------------------*/
		if (P4.6==0){
				sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
		}
		/*------------------*/
		if (P2.3==0){
				sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
		}
		/*------------------*/
		if (P2.2==0){
				sw7_key=0;
		}
		else{
			sw7_key=1;
			sw7_rep=0;
		}
		/*------------------*/
		if (P4.5==0){
				sw8_key=0;
		}
		else{
			sw8_key=1;
			sw8_rep=0;
		}
		/*------------------*/
		if (P4.4==0){
				sw9_key=0;
		}
		else{
			sw9_key=1;
			sw9_rep=0;
		}
		/*------------------*/
		if (P3.4==0){
				sw10_key=0;
		}
		else{
			sw10_key=1;
			sw10_rep=0;
		}
		/*------------------*/
		if (P4.3==0){
				sw11_key=0;
		}
		else{
			sw11_key=1;
			sw11_rep=0;
		}
		/*------------------*/
		if (P4.2==0){
				sw12_key=0;
		}
		else{
			sw12_key=1;
			sw12_rep=0;
		}
		/*------------------*/



		wait_time(500);
		

	/* key scan 2 */
		if ((P2.0==0)&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if ((P4.1==0)&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/
		if ((P4.0==0)&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
		}
		/*------------------*/
		if ((P4.7==0)&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
		}
		/*------------------*/
		if ((P4.6==0)&(sw5_key==0)){
			sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
		}
		/*------------------*/
		if ((P2.3==0)&(sw6_key==0)){
			sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
		}
		/*------------------*/
		if ((P2.2==0)&(sw7_key==0)){
			sw7_key=0;
		}
		else{
			sw7_key=1;
			sw7_rep=0;
		}
		/*------------------*/
		if ((P4.5==0)&(sw8_key==0)){
			sw8_key=0;
		}
		else{
			sw8_key=1;
			sw8_rep=0;
		}
		/*------------------*/
		if ((P4.4==0)&(sw9_key==0)){
			sw9_key=0;
		}
		else{
			sw9_key=1;
			sw9_rep=0;
		}
		/*------------------*/
		if ((P3.4==0)&(sw10_key==0)){
			sw10_key=0;
		}
		else{
			sw10_key=1;
			sw10_rep=0;
		}
		/*------------------*/
		if ((P4.3==0)&(sw11_key==0)){
			sw11_key=0;
		}
		else{
			sw11_key=1;
			sw11_rep=0;
		}
		/*------------------*/
		if ((P4.2==0)&(sw12_key==0)){
			sw12_key=0;
		}
		else{
			sw12_key=1;
			sw12_rep=0;
		}
		/*------------------*/

	/* key action */
	
		if((sw1_key==0)&(sw1_rep==0)){
			rem_out(0x20);off_flg=1;
		}
		if((sw2_key==0)&(sw2_rep==0)){
			rem_out(0x10);off_flg=1;
		}
		if((sw3_key==0)&(sw3_rep==0)){
			rem_out(0x08);off_flg=1;
		}
		if((sw4_key==0)&(sw4_rep==0)){
			rem_out(0x30);off_flg=1;
		}
		if((sw5_key==0)&(sw5_rep==0)){
			rem_out(0x28);off_flg=1;
		}
		if((sw6_key==0)&(sw6_rep==0)){
			rem_out(0x18);off_flg=1;
		}
		if((sw7_key==0)&(sw7_rep==0)){
			rem_out(0x38);off_flg=1;
		}
		if((sw8_key==0)&(sw8_rep==0)){
			rem_out(0x04);off_flg=1;
		}
		if((sw9_key==0)&(sw9_rep==0)){
			rem_out(0x24);off_flg=1;
		}
		if((sw10_key==0)&(sw10_rep==0)){
			rem_out(0x14);off_flg=1;
		}
		if((sw11_key==0)&(sw11_rep==0)){
			rem_out(0x34);off_flg=1;
		}
		if((sw12_key==0)&(sw12_rep==0)){
			rem_out(0x1c);off_flg=1;
		}



		if((P2.0==1)&(P4.1==1)&(P4.0==1)&(P4.7==1)&(P4.6==1)&(P2.3==1)&(P2.2==1)&(P4.5==1)&(P4.4==1)&(P3.4==1)&(P4.3==1)&(P4.2==1)){
			if(off_flg==1){/*rem_out(0x3c)*/;off_flg=0;}
			STOP();
			sw1_key=0;sw1_rep=0;sw2_key=0;sw2_rep=0;sw3_key=0;sw3_rep=0;sw4_key=0;sw4_rep=0;
			sw5_key=0;sw5_rep=0;sw6_key=0;sw6_rep=0;sw7_key=0;sw7_rep=0;sw8_key=0;sw8_rep=0;
			sw9_key=0;sw9_rep=0;sw10_key=0;sw10_rep=0;sw11_key=0;sw11_rep=0;sw12_key=0;sw12_rep=0;
		}

	}
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */



